## ros-humble-google-benchmark-vendor 0.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(google_benchmark_vendor CXX)

option(FORCE_BUILD_VENDOR_PKG
  "Build google benchmark from source, even if system-installed package is available"
  OFF)

if(NOT FORCE_BUILD_VENDOR_PKG)
  find_package(benchmark QUIET)
endif()

macro(build_benchmark)
  set(extra_cmake_args)

  set(GOOGLE_BENCHMARK_TARGET_VERSION "1.5.3")

  if(DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()

  list(APPEND extra_cmake_args "-DBENCHMARK_ENABLE_TESTING=OFF")
  list(APPEND extra_cmake_args "-DBUILD_SHARED_LIBS=ON")
  list(APPEND extra_cmake_args "-DGIT_VERSION=\"${GOOGLE_BENCHMARK_TARGET_VERSION}\"")

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
    if(ANDROID)
      if(DEFINED ANDROID_ABI)
        list(APPEND extra_cmake_args "-DANDROID_ABI=${ANDROID_ABI}")
      endif()
      if(DEFINED ANDROID_CPP_FEATURES)
        list(APPEND extra_cmake_args "-DANDROID_CPP_FEATURES=${ANDROID_CPP_FEATURES}")
      endif()
      if(DEFINED ANDROID_FUNCTION_LEVEL_LINKING)
        list(APPEND extra_cmake_args "-DANDROID_FUNCTION_LEVEL_LINKING=${ANDROID_FUNCTION_LEVEL_LINKING}")
      endif()
      if(DEFINED ANDROID_NATIVE_API_LEVEL)
        list(APPEND extra_cmake_args "-DANDROID_NATIVE_API_LEVEL=${ANDROID_NATIVE_API_LEVEL}")
      endif()
      if(DEFINED ANDROID_NDK)
        list(APPEND extra_cmake_args "-DANDROID_NDK=${ANDROID_NDK}")
      endif()
      if(DEFINED ANDROID_STL)
        list(APPEND extra_cmake_args "-DANDROID_STL=${ANDROID_STL}")
      endif()
      if(DEFINED ANDROID_TOOLCHAIN_NAME)
        list(APPEND extra_cmake_args "-DANDROID_TOOLCHAIN_NAME=${ANDROID_TOOLCHAIN_NAME}")
      endif()
    endif()
  else()
    list(APPEND extra_cmake_args "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
  endif()
  list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}")

  include(ExternalProject)

  externalproject_add(benchmark-${GOOGLE_BENCHMARK_TARGET_VERSION}
    GIT_REPOSITORY https://github.com/google/benchmark.git
    GIT_TAG c05843a9f622db08ad59804c190f98879b76beba  # v${GOOGLE_BENCHMARK_TARGET_VERSION}
    GIT_CONFIG advice.detachedHead=false
    # Suppress git update due to https://gitlab.kitware.com/cmake/cmake/-/issues/16419
    # See https://github.com/ament/uncrustify_vendor/pull/22 for details
    UPDATE_COMMAND ""
    TIMEOUT 600
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install
      ${extra_cmake_args}
    PATCH_COMMAND
      COMMAND ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn ${CMAKE_CURRENT_SOURCE_DIR}/thread_safety_attributes.patch
      COMMAND ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> git apply -p1 --ignore-space-change --whitespace=nowarn ${CMAKE_CURRENT_SOURCE_DIR}/0001-NFCI-Drop-warning-to-satisfy-clang-s-Wunused-but-set.patch
  )

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}
    USE_SOURCE_PERMISSIONS
  )
endmacro()

if(NOT benchmark_FOUND OR "${benchmark_VERSION}" VERSION_LESS 1.5.3)
  build_benchmark()
elseif(benchmark_FOUND)
  # Ubuntu Focal and Jammy have a packaging bug where libbenchmark_main has no symbols,
  # causing linker failures. I'm pretty sure it shouldn't be a static library.
  # Details: https://bugs.launchpad.net/ubuntu/+source/benchmark/+bug/1887872
  get_target_property(_benchmark_main_type benchmark::benchmark_main TYPE)
  if(NOT "${_benchmark_main_type}" STREQUAL "SHARED_LIBRARY")
    build_benchmark()
  endif()
endif()

install(
  FILES package.xml
  DESTINATION share/${PROJECT_NAME}
)

=== debian/changelog ===
ros-humble-google-benchmark-vendor (0.1.2-1bookworm) bookworm; urgency=high

  * Resolve Clang compilation issue with benchmark 1.5.3 (#28 <https://github.com/ament/google_benchmark_vendor/issues/28>)
  * Contributors: Adam Seiwert

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 17 Jul 2023 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.1.1-1bookworm) bookworm; urgency=high

  * Add git buildtool dependency.
  * Contributors: Steven! Ragnarök

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 28 Mar 2022 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.1.0-1bookworm) bookworm; urgency=high

  * Use git hash for google_benchmark_vendor (#20 <https://github.com/ament/google_benchmark_vendor/issues/20>)
  * Update to google benchmark version 1.6.1 (#19 <https://github.com/ament/google_benchmark_vendor/issues/19>)
  * Contributors: Chris Lalancette, Shane Loretz

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 27 Mar 2022 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.7-1bookworm) bookworm; urgency=high

  * Update maintainers to Audrow Nash (#18 <https://github.com/ament/google_benchmark_vendor/issues/18>)
  * Update google_benchmark to v1.5.3 (#16 <https://github.com/ament/google_benchmark_vendor/issues/16>)
    1. Change google_benchmark version from v1.5.2 to v1.5.3. Because v1.5.2
    can not build with GCC 11
    2. Removed shrink-tz-offset-size.patch because of this patch was merged in
    google-benchmark repo.
  * Add changelog (#15 <https://github.com/ament/google_benchmark_vendor/issues/15>)
  * Contributors: Audrow Nash, Homalozoa X, Ivan Santiago Paunovic

 -- Audrow Nash <audrow@openrobotics.org>  Thu, 13 Jan 2022 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.6-1bookworm) bookworm; urgency=high

  * Shrink the size of the tz_offset variable. (#13 <https://github.com/ament/google_benchmark_vendor/issues/13>)
  * Contributors: Chris Lalancette

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 11 Apr 2021 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.5-1bookworm) bookworm; urgency=high

  * Update the patching to work on Windows without admin. (#11 <https://github.com/ament/google_benchmark_vendor/issues/11>)
  * Always preserve source permissions in vendor packages. (#12 <https://github.com/ament/google_benchmark_vendor/issues/12>)
  * Contributors: Chris Lalancette, Scott K Logan

 -- Audrow Nash <audrow@openrobotics.org>  Wed, 17 Mar 2021 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.4-1bookworm) bookworm; urgency=high

  * Update package maintainers. (#10 <https://github.com/ament/google_benchmark_vendor/issues/10>)
  * Upgrade google benchmark from v1.5.1 to v1.5.2 to include QNX patch. (#9 <https://github.com/ament/google_benchmark_vendor/issues/9>)
  * Contributors: Ahmed Sobhy, Michel Hidalgo

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 06 Dec 2020 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.3-1bookworm) bookworm; urgency=high

  * Set the SOVERSION on benchmark libraries. (#8 <https://github.com/ament/google_benchmark_vendor/issues/8>)
  * Contributors: Scott K Logan

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 14 Sep 2020 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.2-1bookworm) bookworm; urgency=high

  * Set minimum criteria for system package. (#3 <https://github.com/ament/google_benchmark_vendor/issues/3>)
  * Work around warnings building Google Benchmark w/Clang. (#2 <https://github.com/ament/google_benchmark_vendor/issues/2>)
  * Contributors: Scott K Logan

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 19 Jul 2020 16:00:00 -0000

ros-humble-google-benchmark-vendor (0.0.1-1bookworm) bookworm; urgency=high

  * Initial google_benchmark_vendor package. (#1 <https://github.com/ament/google_benchmark_vendor/issues/1>)
  * Initial commit.
  * Contributors: Scott K Logan

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 13 Jul 2020 16:00:00 -0000

=== debian/control ===
Source: ros-humble-google-benchmark-vendor
Section: misc
Priority: optional
Maintainer: Audrow Nash <audrow@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), cmake, git, libbenchmark-dev, ros-humble-ros-workspace
Homepage: https://github.com/google/benchmark
Standards-Version: 3.9.2

Package: ros-humble-google-benchmark-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbenchmark-dev, ros-humble-ros-workspace
Description: This package provides Google Benchmark.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-google-benchmark-vendor//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-google-benchmark-vendor//opt/ros/humble/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
